diff -r e32ff462bf6e trytond/modules/account_invoice/invoice.py
--- a/trytond/modules/account_invoice/invoice.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/invoice.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1501,431 +1404,351 @@
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def default_invoice_type(self):
+    @staticmethod
+    def default_invoice_type():
         return Transaction().context.get('invoice_type', 'out_invoice')
 
-    def default_currency(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.id
 
-    def default_currency_digits(self):
-        company_obj = Pool().get('company.company')
+    @staticmethod
+    def default_currency_digits():
+        Company = Pool().get('company.company')
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
             return company.currency.digits
         return 2
 
-    def default_unit_digits(self):
+    @staticmethod
+    def default_unit_digits():
         return 2
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'line'
 
-    def on_change_with_party_lang(self, vals):
-        party_obj = Pool().get('party.party')
-        if vals.get('party'):
-            party = party_obj.browse(vals['party'])
-            if party.lang:
-                return party.lang.code
+    def on_change_with_party_lang(self, name=None):
+        if self.party and self.party.lang:
+            return self.party.lang.code
         return CONFIG['language']
 
-    def get_party_language(self, ids, name):
-        '''
-        Return the language code of the party of each line
+    def on_change_with_unit_digits(self, name=None):
+        if self.unit:
+            return self.unit.digits
+        return 2
 
-        :param ids: the ids of the account.invoice.line
-        :param name: the field name
-        :return: a dictionary with account.invoice.line id as key and
-            language code as value
-        '''
-        res = {}
-        for line in self.browse(ids):
-            if line.party and line.party.lang:
-                res[line.id] = line.party.lang.code
-            else:
-                res[line.id] = CONFIG['language']
-        return res
+    def on_change_with_currency_digits(self, name=None):
+        if self.currency:
+            return self.currency.digits
+        return 2
 
-    def on_change_with_amount(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('type') == 'line':
-            currency = (vals.get('_parent_invoice.currency')
-                or vals.get('currency'))
-            if isinstance(currency, (int, long)) and currency:
-                currency = currency_obj.browse(currency)
-            amount = Decimal(str(vals.get('quantity') or '0.0')) * \
-                    (vals.get('unit_price') or Decimal('0.0'))
+    def on_change_with_amount(self):
+        if self.type == 'line':
+            currency = (self.invoice.currency if self.invoice
+                else self.currency)
+            amount = (Decimal(str(self.quantity or '0.0'))
+                * (self.unit_price or Decimal('0.0')))
             if currency:
-                return currency_obj.round(currency, amount)
+                return currency.round(amount)
             return amount
         return Decimal('0.0')
 
-    def on_change_with_unit_digits(self, vals):
-        uom_obj = Pool().get('product.uom')
-        if vals.get('unit'):
-            uom = uom_obj.browse(vals['unit'])
-            return uom.digits
-        return 2
+    def get_amount(self, name):
+        if self.type == 'line':
+            return self.on_change_with_amount()
+        elif self.type == 'subtotal':
+            subtotal = _ZERO
+            for line2 in self.invoice.lines:
+                if line2.type == 'line':
+                    subtotal += line2.invoice.currency.round(
+                        Decimal(str(line2.quantity)) * line2.unit_price)
+                elif line2.type == 'subtotal':
+                    if self == line2:
+                        break
+                    subtotal = _ZERO
+            return subtotal
+        else:
+            return _ZERO
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            if line.unit:
-                res[line.id] = line.unit.digits
-            else:
-                res[line.id] = 2
-        return res
+    def get_invoice_taxes(self, name):
+        pool = Pool()
+        Tax = pool.get('account.tax')
+        Invoice = pool.get('account.invoice')
 
-    def on_change_with_currency_digits(self, vals):
-        currency_obj = Pool().get('currency.currency')
-        if vals.get('currency'):
-            currency = currency_obj.browse(vals['currency'])
-            return currency.digits
-        return 2
+        if not self.invoice:
+            return
+        context = self.invoice.get_tax_context()
+        taxes_keys = []
+        with Transaction().set_context(**context):
+            taxes = Tax.compute(self.taxes, self.unit_price, self.quantity)
+        for tax in taxes:
+            key, _ = Invoice._compute_tax(tax, self.invoice.type)
+            taxes_keys.append(key)
+        taxes = []
+        for tax in self.invoice.taxes:
+            if tax.manual:
+                continue
+            base_code_id = tax.base_code.id if tax.base_code else None
+            tax_code_id = tax.tax_code.id if tax.tax_code else None
+            tax_id = tax.tax.id if tax.tax else None
+            key = (base_code_id, tax.base_sign,
+                    tax_code_id, tax.tax_sign,
+                    tax.account.id, tax_id)
+            if key in taxes_keys:
+                taxes.append(tax.id)
+        return taxes
 
-    def get_currency_digits(self, ids, name):
-        res = {}
-        for line in self.browse(ids):
-            res[line.id] = line.currency and line.currency.digits or 2
-        return res
-
-    def get_amount(self, ids, name):
-        currency_obj = Pool().get('currency.currency')
-        res = {}
-        for line in self.browse(ids):
-            if line.type == 'line':
-                currency = line.invoice and line.invoice.currency \
-                        or line.currency
-                res[line.id] = currency_obj.round(currency,
-                        Decimal(str(line.quantity)) * line.unit_price)
-            elif line.type == 'subtotal':
-                res[line.id] = _ZERO
-                for line2 in line.invoice.lines:
-                    if line2.type == 'line':
-                        res[line.id] += currency_obj.round(
-                            line2.invoice.currency,
-                            Decimal(str(line2.quantity)) * line2.unit_price)
-                    elif line2.type == 'subtotal':
-                        if line.id == line2.id:
-                            break
-                        res[line.id] = _ZERO
-            else:
-                res[line.id] = _ZERO
-        return res
-
-    def get_invoice_taxes(self, ids, name):
-        tax_obj = Pool().get('account.tax')
-        invoice_obj = Pool().get('account.invoice')
-
-        res = {}
-        for line in self.browse(ids):
-            if not line.invoice:
-                res[line.id] = None
-                continue
-            context = invoice_obj.get_tax_context(line.invoice)
-            tax_ids = [x.id for x in line.taxes]
-            taxes_keys = []
-            with Transaction().set_context(**context):
-                taxes = tax_obj.compute(tax_ids, line.unit_price,
-                        line.quantity)
-            for tax in taxes:
-                key, _ = invoice_obj._compute_tax(tax, line.invoice.type)
-                taxes_keys.append(key)
-            res[line.id] = []
-            for tax in line.invoice.taxes:
-                if tax.manual:
-                    continue
-                key = (tax.base_code.id, tax.base_sign,
-                        tax.tax_code.id, tax.tax_sign,
-                        tax.account.id, tax.tax.id)
-                if key in taxes_keys:
-                    res[line.id].append(tax.id)
-        return res
-
-    def _get_tax_rule_pattern(self, party, vals):
+    def _get_tax_rule_pattern(self):
         '''
         Get tax rule pattern
+        '''
+        return {}
 
-        :param party: the BrowseRecord of the party
-        :param vals: a dictionary with value from on_change
-        :return: a dictionary to use as pattern for tax rule
-        '''
-        res = {}
-        return res
+    def on_change_product(self):
+        pool = Pool()
+        Product = pool.get('product.product')
+        Company = pool.get('company.company')
+        Currency = pool.get('currency.currency')
+        Date = pool.get('ir.date')
 
-    def on_change_product(self, vals):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        party_obj = pool.get('party.party')
-        company_obj = pool.get('company.company')
-        currency_obj = pool.get('currency.currency')
-        tax_rule_obj = pool.get('account.tax.rule')
-        invoice_obj = pool.get('account.invoice')
-        date_obj = pool.get('ir.date')
-
-        if not vals.get('product'):
+        if not self.product:
             return {}
         res = {}
 
         context = {}
         party = None
-        if vals.get('_parent_invoice.party') or vals.get('party'):
-            party = party_obj.browse(vals.get('_parent_invoice.party')
-                    or vals.get('party'))
-            if party.lang:
-                context['language'] = party.lang.code
-
-        product = product_obj.browse(vals['product'])
+        if self.invoice and self.invoice.party:
+            party = self.invoice.party
+        elif self.party:
+            party = self.party
+        if party and party.lang:
+            context['language'] = party.lang.code
 
         company = None
         if Transaction().context.get('company'):
-            company = company_obj.browse(Transaction().context['company'])
+            company = Company(Transaction().context['company'])
         currency = None
-        currency_date = date_obj.today()
-        if '_parent_invoice.currency_date' in vals:
-            if vals['_parent_invoice.currency_date']:
-                currency_date = vals['_parent_invoice.currency_date']
-        elif vals.get('invoice'):
-            invoice = invoice_obj.browse(vals['invoice'])
-            currency_date = invoice.currency_date
-        if vals.get('_parent_invoice.currency') or vals.get('currency'):
-            #TODO check if today date is correct
-            currency = currency_obj.browse(
-                    vals.get('_parent_invoice.currency') or
-                    vals.get('currency'))
+        currency_date = Date.today()
+        if self.invoice and self.invoice.currency_date:
+            currency_date = self.invoice.currency_date
+        #TODO check if today date is correct
+        if self.invoice and self.invoice.currency:
+            currency = self.invoice.currency
+        elif self.currency:
+            currency = self.currency
 
-        if (vals.get('_parent_invoice.type') or vals.get('invoice_type')) \
-                in ('in_invoice', 'in_credit_note'):
+        if self.invoice and self.invoice.type:
+            type_ = self.invoice.type
+        elif self.invoice_type:
+            type_ = self.invoice_type
+        if type_ in ('in_invoice', 'in_credit_note'):
             if company and currency:
                 with Transaction().set_context(date=currency_date):
-                    res['unit_price'] = currency_obj.compute(
-                            company.currency.id, product.cost_price,
-                            currency.id, round=False)
+                    res['unit_price'] = Currency.compute(
+                        company.currency, self.product.cost_price,
+                        currency, round=False)
             else:
-                res['unit_price'] = product.cost_price
+                res['unit_price'] = self.product.cost_price
             try:
-                res['account'] = product.account_expense_used.id
-                res['account.rec_name'] = product.account_expense_used.rec_name
+                account_expense = self.product.account_expense_used
+                res['account'] = account_expense.id
+                res['account.rec_name'] = account_expense.rec_name
             except Exception:
                 pass
             res['taxes'] = []
-            pattern = self._get_tax_rule_pattern(party, vals)
-            for tax in product.supplier_taxes_used:
+            pattern = self._get_tax_rule_pattern()
+            for tax in self.product.supplier_taxes_used:
                 if party and party.supplier_tax_rule:
-                    tax_ids = tax_rule_obj.apply(party.supplier_tax_rule, tax,
-                            pattern)
+                    tax_ids = party.supplier_tax_rule.apply(tax, pattern)
                     if tax_ids:
                         res['taxes'].extend(tax_ids)
                     continue
                 res['taxes'].append(tax.id)
             if party and party.supplier_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.supplier_tax_rule, None,
-                        pattern)
+                tax_ids = party.supplier_tax_rule.apply(None, pattern)
                 if tax_ids:
                     res['taxes'].extend(tax_ids)
         else:
             if company and currency:
                 with Transaction().set_context(date=currency_date):
-                    res['unit_price'] = currency_obj.compute(
-                            company.currency.id, product.list_price,
-                            currency.id, round=False)
+                    res['unit_price'] = Currency.compute(
+                        company.currency, self.product.list_price,
+                        currency, round=False)
             else:
-                res['unit_price'] = product.list_price
+                res['unit_price'] = self.product.list_price
             try:
-                res['account'] = product.account_revenue_used.id
-                res['account.rec_name'] = product.account_revenue_used.rec_name
+                account_revenue = self.product.account_revenue_used
+                res['account'] = account_revenue.id
+                res['account.rec_name'] = account_revenue.rec_name
             except Exception:
                 pass
             res['taxes'] = []
-            pattern = self._get_tax_rule_pattern(party, vals)
-            for tax in product.customer_taxes_used:
+            pattern = self._get_tax_rule_pattern()
+            for tax in self.product.customer_taxes_used:
                 if party and party.customer_tax_rule:
-                    tax_ids = tax_rule_obj.apply(party.customer_tax_rule, tax,
-                            pattern)
+                    tax_ids = party.customer_tax_rule.apply(tax, pattern)
                     if tax_ids:
                         res['taxes'].extend(tax_ids)
                     continue
                 res['taxes'].append(tax.id)
             if party and party.customer_tax_rule:
-                tax_ids = tax_rule_obj.apply(party.customer_tax_rule, None,
-                        pattern)
+                tax_ids = party.customer_tax_rule.apply(None, pattern)
                 if tax_ids:
                     res['taxes'].extend(tax_ids)
 
-        if not vals.get('description'):
+        if not self.description:
             with Transaction().set_context(**context):
-                res['description'] = product_obj.browse(product.id).rec_name
+                res['description'] = Product(self.product.id).rec_name
 
-        category = product.default_uom.category
-        if not vals.get('unit') \
-                or vals.get('unit') not in [x.id for x in category.uoms]:
-            res['unit'] = product.default_uom.id
-            res['unit.rec_name'] = product.default_uom.rec_name
-            res['unit_digits'] = product.default_uom.digits
+        category = self.product.default_uom.category
+        if not self.unit or self.unit not in category.uoms:
+            res['unit'] = self.product.default_uom.id
+            res['unit.rec_name'] = self.product.default_uom.rec_name
+            res['unit_digits'] = self.product.default_uom.digits
 
-        vals = vals.copy()
-        vals['unit_price'] = res['unit_price']
-        vals['type'] = 'line'
-        res['amount'] = self.on_change_with_amount(vals)
+        self.unit_price = res['unit_price']
+        self.type = 'line'
+        res['amount'] = self.on_change_with_amount()
         return res
 
-    def on_change_with_product_uom_category(self, values):
-        pool = Pool()
-        product_obj = pool.get('product.product')
-        if values.get('product'):
-            product = product_obj.browse(values['product'])
-            return product.default_uom_category.id
+    def on_change_with_product_uom_category(self, name=None):
+        if self.product:
+            return self.product.default_uom_category.id
 
-    def get_product_uom_category(self, ids, name):
-        categories = {}
-        for line in self.browse(ids):
-            if line.product:
-                categories[line.id] = line.product.default_uom_category.id
-            else:
-                categories[line.id] = None
-        return categories
-
-    def on_change_account(self, values):
-        pool = Pool()
-        party_obj = pool.get('party.party')
-        account_obj = pool.get('account.account')
-        tax_rule_obj = pool.get('account.tax.rule')
-
-        if values.get('product'):
+    def on_change_account(self):
+        if self.product:
             return {}
         taxes = []
         result = {
             'taxes': taxes,
-        }
-        if (values.get('_parent_invoice.party')
-                and values.get('_parent_invoice.type')):
-            party = party_obj.browse(values['_parent_invoice.party'])
-            if values['_parent_invoice.type'] in ('in_invoice',
-                    'in_credit_note'):
+            }
+        if (self.invoice and self.invoice.party
+                and self.invoice.type):
+            party = self.invoice.party
+            if self.invoice.type in ('in_invoice', 'in_credit_note'):
                 tax_rule = party.supplier_tax_rule
             else:
                 tax_rule = party.customer_tax_rule
         else:
             tax_rule = None
 
-        if values.get('account'):
-            account = account_obj.browse(values['account'])
-            pattern = self._get_tax_rule_pattern(party, values)
-            for tax in account.taxes:
+        if self.account:
+            pattern = self._get_tax_rule_pattern()
+            for tax in self.account.taxes:
                 if tax_rule:
-                    tax_ids = tax_rule_obj.apply(tax_rule, tax, pattern)
+                    tax_ids = tax_rule.apply(tax, pattern)
                     if tax_ids:
                         taxes.extend(tax_ids)
                     continue
                 taxes.append(tax.id)
         return result
 
-    def check_modify(self, ids):
+    @classmethod
+    def check_modify(cls, lines):
         '''
         Check if the lines can be modified
         '''
-        for line in self.browse(ids):
-            if line.invoice and \
-                    line.invoice.state in ('open', 'paid'):
-                self.raise_user_error('modify')
-        return
+        for line in lines:
+            if (line.invoice
+                    and line.invoice.state in ('open', 'paid')):
+                cls.raise_user_error('modify')
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
-        return super(InvoiceLine, self).delete(ids)
+    @classmethod
+    def delete(cls, lines):
+        cls.check_modify(lines)
+        super(InvoiceLine, cls).delete(lines)
 
-    def write(self, ids, vals):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        self.check_modify(ids)
-        return super(InvoiceLine, self).write(ids, vals)
+    @classmethod
+    def write(cls, lines, vals):
+        cls.check_modify(lines)
+        super(InvoiceLine, cls).write(lines, vals)
 
-    def create(self, vals):
-        invoice_obj = Pool().get('account.invoice')
+    @classmethod
+    def create(cls, vals):
+        Invoice = Pool().get('account.invoice')
         if vals.get('invoice'):
-            invoice = invoice_obj.browse(vals['invoice'])
+            invoice = Invoice(vals['invoice'])
             if invoice.state in ('open', 'paid', 'cancel'):
-                self.raise_user_error('create')
-        return super(InvoiceLine, self).create(vals)
+                cls.raise_user_error('create')
+        return super(InvoiceLine, cls).create(vals)
 
-    def check_account(self, ids):
-        for line in self.browse(ids):
-            if line.type == 'line':
-                if line.invoice:
-                    if line.account.company.id != line.invoice.company.id:
-                        return False
-                elif line.company:
-                    if line.account.company.id != line.company.id:
-                        return False
-        return True
-
-    def check_account2(self, ids):
-        for line in self.browse(ids):
-            if line.type == 'line':
-                if line.invoice \
-                        and line.account.id == line.invoice.account.id:
+    def check_account(self):
+        if self.type == 'line':
+            if self.invoice:
+                if self.account.company != self.invoice.company:
+                    return False
+            elif self.company:
+                if self.account.company != self.company:
                     return False
         return True
 
-    def _compute_taxes(self, line):
+    def check_account2(self):
+        if self.type == 'line':
+            if (self.invoice
+                    and self.account == self.invoice.account):
+                return False
+        return True
+
+    def _compute_taxes(self):
         pool = Pool()
-        tax_obj = pool.get('account.tax')
-        currency_obj = pool.get('currency.currency')
-        invoice_obj = pool.get('account.invoice')
+        Tax = pool.get('account.tax')
+        Currency = pool.get('currency.currency')
 
-        context = invoice_obj.get_tax_context(line.invoice)
+        context = self.invoice.get_tax_context()
         res = []
-        if line.type != 'line':
+        if self.type != 'line':
             return res
-        tax_ids = [x.id for x in line.taxes]
         with Transaction().set_context(**context):
-            taxes = tax_obj.compute(tax_ids, line.unit_price, line.quantity)
+            taxes = Tax.compute(self.taxes, self.unit_price, self.quantity)
         for tax in taxes:
-            if line.invoice.type in ('out_invoice', 'in_invoice'):
-                base_code_id = tax['tax'].invoice_base_code.id
+            if self.invoice.type in ('out_invoice', 'in_invoice'):
+                base_code_id = (tax['tax'].invoice_base_code.id
+                    if tax['tax'].invoice_base_code else None)
                 amount = tax['base'] * tax['tax'].invoice_base_sign
             else:
-                base_code_id = tax['tax'].credit_note_base_code.id
+                base_code_id = (tax['tax'].credit_note_base_code.id
+                    if tax['tax'].credit_note_base_code else None)
                 amount = tax['base'] * tax['tax'].credit_note_base_sign
             if base_code_id:
                 with Transaction().set_context(
-                        date=line.invoice.currency_date):
-                    amount = currency_obj.compute(line.invoice.currency.id,
-                            amount, line.invoice.company.currency.id)
+                        date=self.invoice.currency_date):
+                    amount = Currency.compute(self.invoice.currency,
+                        amount, self.invoice.company.currency)
                 res.append({
-                    'code': base_code_id,
-                    'amount': amount,
-                    'tax': tax['tax'].id
-                })
+                        'code': base_code_id,
+                        'amount': amount,
+                        'tax': tax['tax'].id if tax['tax'] else None,
+                        })
         return res
 
-    def get_move_line(self, line):
+    def get_move_line(self):
         '''
         Return a list of move lines values for invoice line
         '''
-        currency_obj = Pool().get('currency.currency')
+        Currency = Pool().get('currency.currency')
         res = {}
-        if line.type != 'line':
+        if self.type != 'line':
             return []
-        res['name'] = line.description
-        if line.invoice.currency.id != line.invoice.company.currency.id:
-            with Transaction().set_context(date=line.invoice.currency_date):
-                amount = currency_obj.compute(line.invoice.currency.id,
-                        line.amount, line.invoice.company.currency.id)
-            res['amount_second_currency'] = line.amount
-            res['second_currency'] = line.invoice.currency.id
+        res['name'] = self.description
+        if self.invoice.currency != self.invoice.company.currency:
+            with Transaction().set_context(date=self.invoice.currency_date):
+                amount = Currency.compute(self.invoice.currency,
+                    self.amount, self.invoice.company.currency)
+            res['amount_second_currency'] = self.amount
+            res['second_currency'] = self.invoice.currency.id
         else:
-            amount = line.amount
+            amount = self.amount
             res['amount_second_currency'] = Decimal('0.0')
             res['second_currency'] = None
-        if line.invoice.type in ('in_invoice', 'out_credit_note'):
+        if self.invoice.type in ('in_invoice', 'out_credit_note'):
             if amount >= Decimal('0.0'):
                 res['debit'] = amount
                 res['credit'] = Decimal('0.0')
@@ -1941,15 +1764,15 @@
             else:
                 res['debit'] = - amount
                 res['credit'] = Decimal('0.0')
-        res['account'] = line.account.id
-        res['party'] = line.invoice.party.id
-        computed_taxes = self._compute_taxes(line)
+        res['account'] = self.account.id
+        res['party'] = self.invoice.party.id
+        computed_taxes = self._compute_taxes()
         for tax in computed_taxes:
             res.setdefault('tax_lines', [])
             res['tax_lines'].append(('create', tax))
         return [res]
 
-    def _credit(self, line):
+    def _credit(self):
         '''
         Return values to credit line.
         '''
@@ -1957,38 +1780,31 @@
 
         for field in ('sequence', 'type', 'quantity', 'unit_price',
                 'description'):
-            res[field] = line[field]
+            res[field] = getattr(self, field)
 
         for field in ('unit', 'product', 'account'):
-            res[field] = line[field].id
+            res[field] = getattr(self, field).id
 
         res['taxes'] = []
-        for tax in line.taxes:
+        for tax in self.taxes:
             res['taxes'].append(('add', tax.id))
         return res
 
-InvoiceLine()
-
 
 class InvoiceLineTax(ModelSQL):
     'Invoice Line - Tax'
-    _name = 'account.invoice.line-account.tax'
+    __name__ = 'account.invoice.line-account.tax'
     _table = 'account_invoice_line_account_tax'
-    _description = __doc__
     line = fields.Many2One('account.invoice.line', 'Invoice Line',
             ondelete='CASCADE', select=True, required=True)
     tax = fields.Many2One('account.tax', 'Tax', ondelete='RESTRICT',
             required=True)
 
-InvoiceLineTax()
-
 
 class InvoiceTax(ModelSQL, ModelView):
     'Invoice Tax'
-    _name = 'account.invoice.tax'
+    __name__ = 'account.invoice.tax'
     _rec_name = 'description'
-    _description = __doc__
-
     invoice = fields.Many2One('account.invoice', 'Invoice', ondelete='CASCADE',
             select=True)
     description = fields.Char('Description', size=None, required=True)
